package Flier_Match.FMCliente.motion;

import java.util.ArrayList;

import Flier_Match.FMCliente.sistema.Parametros;
import Flier_Match.FMCliente.sonido.ManejadorSonidos;

import com.threed.jpct.Camera;
import com.threed.jpct.Loader;
import com.threed.jpct.Object3D;
import com.threed.jpct.SimpleVector;
import com.threed.jpct.World;

public class ManejadorDisparos {

	private ArrayList disparos;
	
	private Bullet bala1;
	private Bullet bala2;
	private Bullet misil1;
	private Bullet misil2;
	
	private ManejadorSonidos SoundManager;
	
	private BulletListener ManejadorColisionesBalas;
	
	public ManejadorDisparos (ManejadorSonidos SM) {
		crearBalas ();
		disparos=new ArrayList ();
		SoundManager=SM;
		ManejadorColisionesBalas=new BulletListener ("");
	}
	
	public void crearBalas () {
		System.out.println ("Creando las balas PREDEFINIDAS");
		bala1=buildBala (Bullet.BULLET_BALA1);
		bala2=buildBala (Bullet.BULLET_BALA2);
		misil1=buildBala (Bullet.BULLET_MISIL1);
		misil2=buildBala (Bullet.BULLET_MISIL2);
		System.out.println ("balas PREDEFINIDAS creadas");
	}
	
	public Bullet buildBala (int tipoBala) {
		Parametros P=new Parametros ();
		String balaPath="";
		String balaTex="";
		float velocidad=1f;
		int danio=1;
		
		if (tipoBala==Bullet.BULLET_BALA1) {
			balaPath=P.getPath()+"Recursos/3DS/Disparos/bala1.MD2";
			velocidad=20f;
			danio=10;
			balaTex="BALA1.JPG";
		}
		if (tipoBala==Bullet.BULLET_BALA2) {
			balaPath=P.getPath()+"Recursos/3DS/Disparos/bala2.MD2";
			velocidad=40f;
			danio=20;
			balaTex="BALA2.JPG";
		}
		if (tipoBala==Bullet.BULLET_MISIL1) {
			balaPath=P.getPath()+"Recursos/3DS/Disparos/misil1.MD2";
			velocidad=10f;
			danio=35;
			balaTex="MISIL1.JPG";
		}
		if (tipoBala==Bullet.BULLET_MISIL2) {
			balaPath=P.getPath()+"Recursos/3DS/Disparos/misil2.MD2";
			velocidad=15f;
			danio=65;
			balaTex="MISIL2.JPG";
		}
		
		Object3D modeloBala=Loader.loadMD2 (balaPath, 1f);
		modeloBala.setCollisionMode(Object3D.COLLISION_CHECK_OTHERS | Object3D.COLLISION_CHECK_SELF);
		Bullet bala=new Bullet (modeloBala, velocidad, danio);
		bala.setTexture(balaTex);
		return bala;
	}
	
	
	public void addDisparo (SimpleVector pos, SimpleVector dir, int tipoBala, World mundo, Camera cam) {
		
		Bullet bala=null;
		if (tipoBala==Bullet.BULLET_BALA1) {
			bala=new Bullet (bala1);
		}
		if (tipoBala==Bullet.BULLET_BALA2) {
			bala=new Bullet (bala2);
		}
		if (tipoBala==Bullet.BULLET_MISIL1) {
			bala=new Bullet (misil1);
		}
		if (tipoBala==Bullet.BULLET_MISIL2) {
			bala=new Bullet (misil2);
		}
		System.out.println ("Disparo AGREGADO EN POS: "+pos+" - DIR: "+dir);
		Disparo D=new Disparo (pos, dir, SoundManager, bala, mundo, cam);//TODO falta alinear la bala con la nave
		D.setBulletListener (ManejadorColisionesBalas);
		disparos.add (D);
	}
	
	public void moverDisparos () {
		
		for (int i=0;i<disparos.size();i++) {
			Disparo d=(Disparo)disparos.get(i);
			if (!d.estaAnimando()) {
				//System.out.println ("La nueva posicion calculada es: "+d.calcularNuevaPosicionDirecta());
				d.avanzarDirecto();
				//System.out.println("Posicion: "+d.getPosicionInicial()+" - Direccion: "+d.getDireccion());
				//System.out.println("Translacion: "+d.getBala().getTranslation());
				if (ManejadorColisionesBalas.getSource()!=null){
					System.out.println ("Hubo una colision de la bala.");
					d.setAnimando(true);
				}
			}else {
				if (!d.AnimarExplosion()) quitarDisparo (i);
			}
			
		}
	}
	
	public void quitarDisparo (int index) {
		disparos.remove(index);
	}
	
}
