/*
 * GameLoop.java
 *
 * Created on 6 de marzo de 2006, 14:39
 */

package Flier_Match.FMCliente.sistema;
import java.awt.Color;
import java.io.File;

import Flier_Match.FMCliente.motion.BulletThread;
import Flier_Match.FMCliente.sonido.ManejadorSonidos;
import Flier_Match.FMCliente.video.RenderThread;

import com.threed.jpct.Camera;
import com.threed.jpct.Config;
import com.threed.jpct.Lights;
import com.threed.jpct.Loader;
import com.threed.jpct.Matrix;
import com.threed.jpct.Object3D;
import com.threed.jpct.SimpleVector;
import com.threed.jpct.Texture;
import com.threed.jpct.TextureManager;
import com.threed.jpct.World;
/**
 *
 * @author  Administrador
 * @version 
 */
public class GameLoop {
    public World Menu;
    public World Naves;
    public World Trailer;
    public World Splash;
    
    static public Object3D seleccionador;
    
    static public TextureManager TM;
    
    public String path;
    public Parametros param;

    public Camera camTrailer;
    
    public Lista navesLista;
    
    public String IP;
    public int port;
    /** Creates new GameLoop */
    public GameLoop(String aIP, int aPort) {
        IP=aIP;
        port=aPort;

        param=new Parametros ();
        param=param.cargar ();
        path=param.getPath ();
        
        Config.farPlane=4000;
        Config.maxPolysVisible=15000;
        
        if (param.getRender ()==2) {
            Config.glMipmap=true;
            Config.glWindowName="Flier Match";
            //Config.glFullscreen=true; //deshabilitar por motivos de debug, habilitar para el deploy
        } else if (param.getRender ()==1) {
        	
        }
        
        cargarTexturas ("Recursos/Texturas/");
        cargarTexturas ("Recursos/Texturas/Colores/");
        cargarTexturas ("Recursos/Texturas/Splash/");
        cargarSplash ();
        cargarMenu ();
        cargarNaves ();
        //cargarTrailers ();
        

        ManejadorSonidos player=new ManejadorSonidos ();
        
        ManejadorEventos eventos=new ManejadorEventos (TM);
        RenderThread render=new RenderThread (param, navesLista, Menu, Naves, Trailer, Splash, IP, port, eventos, player);
        BulletThread balas=new BulletThread (player);
        
        eventos.setRenderThread (render);
        eventos.setBulletThread (balas);
        render.start ();
        balas.start();
    }
    
    public void cargarNaves () {
        Naves=new World ();
        Camera camNaves=Naves.getCamera ();
        camNaves.setPosition (new SimpleVector (0, -20, -55));
        camNaves.lookAt (new SimpleVector (0, -2, 2));
        cargarLucesNaves ();
        cargarMapaNaves ();
        Naves.getLights().setOverbrightLighting(Lights.OVERBRIGHT_LIGHTING_DISABLED);
        Naves.buildAllObjects ();
    }
    
    public void setTextureColor (Object3D parteColor) {
        switch (param.getColor ()) {
            case 1: {
                parteColor.setTexture ("ROJO.JPG");
                break;
            }
            case 2: {
            	parteColor.setTexture ("AZUL.JPG");
                break;
            }
            case 3: {
            	parteColor.setTexture ("VERDE.JPG");
                break;
            }
            case 4: {
            	parteColor.setTexture ("BLANCO.JPG");
                break;
            }
            case 5: {
            	parteColor.setTexture ("AMARILLO.JPG");
                break;
            }
            default: break;
        };
    
    }
    
    private void cargarLucesNaves () {
        Naves.setAmbientLight (50, 50, 50);
        Naves.addLight (new SimpleVector (0, -100, 0), 150, 150, 150);
        //aadir mas luces de ser necesario
    }
    
    public void cargarMapaNaves () {
        navesLista = new Lista ();
        File dir=new File (path+"Recursos/3DS/Naves/");
        String nombres []=dir.list ();
        
        Object3D partesFuego=null;
        Object3D partesColor=null;
        
        for (int j=0;j<nombres.length;j++) {
            Object3D navesMap=new Object3D (0);
            Object3D partes []=null;
            Object3D parteFuego=null;
            Object3D parteColor=null;
            if (nombres [j].endsWith (".3DS")) partes=Loader.load3DS (path+"Recursos/3DS/Naves/"+nombres [j], 0.2f);
            for (int i=0;i<partes.length;i++) {
                Object3D part=partes [i];

                part.setCenter(SimpleVector.ORIGIN);
                part.rotateX((float)-Math.PI/2);
                part.rotateMesh();
                part.setRotationMatrix(new Matrix());

                if (part.getName ().toLowerCase().startsWith ("fuego")) {
                	parteFuego=part;
                	parteFuego.setAdditionalColor(new Color (255, 255, 255));
                } else {
                	if (part.getName ().toLowerCase().startsWith ("color")) {
                		parteColor=part;
                    	setTextureColor (parteColor);
                	}
                    navesMap=Object3D.mergeObjects (part, navesMap);

                }
                	
                
            }
            if (nombres [j].compareTo ("Base.3DS")!=0) {
                System.out.println ("\n--------------- Ingresando nave: "+nombres [j]+" en la lista");
                navesMap.setCollisionMode (Object3D.COLLISION_CHECK_OTHERS | Object3D.COLLISION_CHECK_SELF);
                navesMap.addChild(parteFuego);
                navesLista.insertar (navesMap);
                
            } else {
            	parteFuego=null;
                parteColor=null;
            }

            Naves.addObject (navesMap);
            
            if (parteFuego!=null)Naves.addObject (parteFuego);

        }
        dir=null;
    }
    
    public void cargarMenu () {
        Menu=new World ();
        Camera camMenu=Menu.getCamera ();
        camMenu.setPosition (new SimpleVector (0, -44, -742));
        cargarMapaMenu ();
        cargarLucesMenu ();
        Menu.getLights().setOverbrightLighting(Lights.OVERBRIGHT_LIGHTING_DISABLED);
        Menu.buildAllObjects ();
    }
    
    public void cargarLucesMenu () {
        Menu.setAmbientLight (210, 210, 210);
        Menu.addLight (new SimpleVector (0, 0, -100), 140, 140, 140);
    }
    
    public void cargarSplash () {
        Splash=new World ();
        Camera cam=Splash.getCamera ();
        cam.setPosition (new SimpleVector (0, 0, -620));
        //cam.setPosition (new SimpleVector (400, 0, -400));
        cam.lookAt(new SimpleVector (0, 0, 0));
        cargarMapaSplash ();
        cargarLucesSplash ();
        Splash.getLights().setOverbrightLighting(Lights.OVERBRIGHT_LIGHTING_DISABLED);
        Splash.buildAllObjects ();
    }
    
    public void cargarLucesSplash () {
        Splash.setAmbientLight (240, 240, 240);
        //Splash.addLight (new SimpleVector (0, 0, -100), 140, 140, 140);
    }
    
    public void cargarMapaSplash () {
    	Object3D SP=new Object3D (0);
    	
        Object3D partes []=Loader.load3DS (path+"Recursos/3DS/SPLASH/SPLASH1.3DS", 1f);
        
        for (int i=0;i<partes.length;i++) {
            Object3D part=partes [i];
         
            part.setCenter(SimpleVector.ORIGIN);
            part.rotateX((float)-Math.PI/2);
            part.rotateMesh();
            part.setRotationMatrix(new Matrix());
            if ((i&1)==1) part.setTransparency(0);
            
            SP=Object3D.mergeObjects (part, SP);

        }
        
        Object3D parte1=loadMD2 (path+"Recursos/3DS/SPLASH/SPJAVA.md2", 1f);
        parte1.setName("SPJAVA");
        parte1.setTexture("javaL.JPG");
        Splash.addObject (parte1);
        
        Object3D parte2=loadMD2 (path+"Recursos/3DS/SPLASH/SPOGL.md2", 1f);
        parte2.setName("SPOGL");
        parte2.setTexture("openglL.JPG");
        Splash.addObject (parte2);
        
        Object3D parte3=loadMD2 (path+"Recursos/3DS/SPLASH/SPOAL.md2", 1f);
        parte3.setName("SPOAL");
        parte3.setTexture("openalL.JPG");
        Splash.addObject (parte3);
        
        Object3D parte4=loadMD2 (path+"Recursos/3DS/SPLASH/SPLWJGL.md2", 1f);
        parte4.setName("SPLWJGL");
        parte4.setTexture("lwjglL.JPG");
        Splash.addObject (parte4);
        
        Object3D parte5=loadMD2 (path+"Recursos/3DS/SPLASH/SPJPCT.md2", 1f);
        parte5.setName("SPJPCT");
        parte5.setTexture("jpctL.JPG");
        Splash.addObject (parte5);
        
        SP.setName("SplashFondo");
        Splash.addObject (SP);
        
    }
    
    public Object3D loadMD2 (String path, float escala) {
    	Object3D part=Loader.loadMD2(path, escala);
        /*
        part.setCenter(SimpleVector.ORIGIN);
        part.rotateX((float)-Math.PI/2);
        part.rotateMesh();
        part.setRotationMatrix(new Matrix());*/
        
        return part;
    }
    
    public void cargarTexturas (String directorio) {
        File dir=new File (path+directorio);
        String nombres []=dir.list ();
        TM=TextureManager.getInstance ();
        for (int i=0;i<nombres.length;i++) {
        	if ((nombres [i].toUpperCase()).endsWith("JPG"))TM.addTexture (nombres [i], new Texture (path+directorio+nombres [i]));
        }
        dir=null;
    }
    
    public void cargarMapaMenu () {
    	Object3D menuMap=new Object3D (0);
        Object3D partes []=Loader.load3DS (path+"Recursos/3DS/Menu/Menu.3DS", 1f);
        seleccionador=new Object3D (0);
        for (int i=0;i<partes.length;i++) {
            Object3D part=partes [i];
         
            part.setCenter(SimpleVector.ORIGIN);
            part.rotateX((float)-Math.PI/2);
            part.rotateMesh();
            part.setRotationMatrix(new Matrix());
            if ((i&1)==1) part.setTransparency(0);
            
            if (part.getName ().startsWith ("S1") || part.getName ().startsWith ("S2")) {
                seleccionador=Object3D.mergeObjects (seleccionador, part);
            }
            else {
                menuMap=Object3D.mergeObjects (menuMap, part);
            }
        }
        Menu.addObject (menuMap);
        Menu.addObject (seleccionador);
    }

}
